<?php

$path2root = '../../';
include $path2root.'begin.php'; 
$cms['tngpath'] = $path2root;
include $cms['tngpath'].'adminlib.php';
include $cms['tngpath'].$mylanguage.'/admintext.php';
include $cms['tngpath'].'checklogin.php';

$title="Private Media Mod (PMM) database installation";
echo "<html>
<title>$title</title>
<meta name='robots' content='noindex,nofollow'>
</head>
<body background='../../img/background.gif'>
<form action='dbchange.php' method='get'>
<table bgcolor='#faf4e6' style='width:70%; margin-left:15%; margin-right:15%;'>
<tr><td colspan=3><h2><center>$title</center></h2></td></tr><tr>
";
$install =$_GET['install'];
$remove = $_GET['remove'];
$t="tinyint(4)";
$total=3; $added=$dropped=0;
$count= installed($media_table,'private',$t) +
	installed($albums_table,'private',$t) +
	installed($users_table,'allow_privatemedia',$t);
	
#print "install=$install remove=$remove\n";

if ($install=="Install") {
	 if ($count<$total) {
	 	$added = addcolumn($media_table, 'private', 'alwayson') +
	 		addcolumn($albums_table, 'private', 'alwayson') +
	 		addcolumn($users_table, 'allow_privatemedia', 'allow_private');
	 	$count += $added;
	 }
}
else if ($remove=="Remove anyway") {
	if ($count>0) {
		$dropped = removecolumn($media_table, 'private') +
	 		removecolumn($albums_table, 'private') +
	 		removecolumn($reports_table, 'private') +		#leave this for now
	 		removecolumn($users_table, 'allow_privatemedia') +
	 		removecolumn($users_table, 'allow_privatereport');		#leave
	 	$count -= $dropped;
 	}
}
#print "count=$count, total=$total, installed=$added, dropped=$dropped";
echo "<td colspan=3>";
if ($install=="Install" && $added<$total) echo "Installation not complete. ($added out of $total completed.) Please check your database settings.<br /><br />\n";
if ($remove=="Remove anyway" && $dropped<$total) echo "Removal not complete. ($dropped out of $total completed.) Please check your database settings.<br /><br />\n";
if ($added) echo "Database changes for Private Media have been installed.<br /><br />\n";
if ($dropped) echo "Database changes for Private Media have been removed.<br /><br />\n";

if (!$count && !$dropped) {
	echo "Ok to make database modifications for Private Media<br />\n";
	echo "Click the <em>Install</em> Button to proceed.<br /><br />\n";
}
if ($count==$total && !$added) 
	echo "Database installation for Private Media has already been done.<br /><br />\n";

if ($count>0 && $count<$total) {
	echo "Changes ($count out of $total) have been partially made to the database for Private Media.<br /><br />\n";
	echo "You can try again to see if it works properly.<br /><br />";
}
if(!$dropped)	echo "If you want to uninstall PM you <em>shouldn't</em> normally
	remove the database changes as any settings you have entered with
	private media will be lost.  
	You can later reinstall the mod without making changes to the database.
	The database changes will not affect the TNG program.<br />\n";
echo "</td></tr><td>&nbsp;</td><tr></tr><tr>\n";

if ($count<$total) {
	echo "<td><input  name='install' value='Install' type='submit' ></td>\n";
}
if ($count>0) {
	echo "<td><input name='remove' value='Remove anyway' type='submit' ></td>\n";
}
	echo "<td><input name='Cancel' value='Return to mod manager' type='button' onclick=\"location.href='../../admin_modhandler.php'\" ></td>\n";

echo "</tr><table></form>\n"; 


function installed($table,$column,$type) {
	global $link;
	$result=mysqli_query($link,"show columns from $table like '$column'");
	$row=mysqli_fetch_assoc($result);
	if ($row['Type']==$type) return 1;
	return 0;
} 

function addcolumn($table,$column,$after) {
	global $link;
	if(mysqli_query($link,"ALTER table $table ADD $column tinyint DEFAULT 0 AFTER $after"))
		return 1;
	else return 0;
}

function removecolumn($table,$column) {
	global $link;
	if(mysqli_query($link,"ALTER table $table DROP $column")) 
		return 1;
	else return 0;
}
?>
